<form [formGroup]="product">
    <div class="row">
        <div class="col-12">
            <section class="widget" widget>
                <header>
                    <h6>
                        Basic information
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset>
                        <div class="row">
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-name" class="col-md-4  col-form-label text-md-right">Name</label>
                                <div class="col-md-7 ">
                                    <input type="text" id="normal-name" formControlName="name" class="form-control"
                                        placeholder="">
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-origin" class="col-md-4  col-form-label text-md-right">Origin</label>
                                <div class="col-md-7 ">
                                    <input type="text" id="normal-origin" formControlName="origin" class="form-control"
                                        placeholder="">
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-origin" class="col-md-4  col-form-label text-md-right">Languages</label>
                                <div class="col-md-7 ">
                                    <p-multiSelect [options]="languages" [style]="{'min-width': '100%'}" formControlName="languages"></p-multiSelect>
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-description"
                                    class="col-md-4  col-form-label text-md-right">Description</label>
                                <div class="col-md-7 ">
                                    <textarea rows="4" class="form-control" id="normal-description"
                                        formControlName="description"></textarea>
                                </div>
                            </div>
                        </div>
                    </fieldset>
                </div>
            </section>
            <section class="widget" widget>
                <header>
                    <h6>
                        Location
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset formGroupName="address">
                        <div class="col-12 text-right">
                            <button (click)="addressLookup = true" class="btn btn-primary rounded-circle">
                                <i class="fa fa-plus"></i>
                            </button>
                        </div>
                        <div class="row">
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-country"
                                    class="col-md-4  col-form-label text-md-right">Country</label>
                                <div class="col-md-7 ">
                                    <input type="text" disabled id="normal-country" formControlName="country"
                                        class="form-control" placeholder="">
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-state" class="col-md-4  col-form-label text-md-right">State</label>
                                <div class="col-md-7 ">
                                    <input type="text" id="normal-state" formControlName="state" class="form-control"
                                        placeholder="">
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-city" class="col-md-4  col-form-label text-md-right">City</label>
                                <div class="col-md-7 ">
                                    <input type="text" id="normal-city" formControlName="city" class="form-control"
                                        placeholder="">
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-locality"
                                    class="col-md-4  col-form-label text-md-right">Locality</label>
                                <div class="col-md-7 ">
                                    <input type="text" id="normal-locality" formControlName="locality"
                                        class="form-control" placeholder="">
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-zipCode"
                                    class="col-md-4  col-form-label text-md-right">ZipCode</label>
                                <div class="col-md-7 ">
                                    <input type="text" id="normal-zipCode" formControlName="zipCode"
                                        class="form-control" placeholder="">
                                </div>
                            </div>
                        </div>
                        <div formGroupName="location" class="row">
                            <div class="form-group col-md-12 col-lg-6 row">
                                <label for="normal-cordinates"
                                    class="col-md-4  col-form-label text-md-right">Cordinates</label>
                                <div class="col-md-7 ">
                                    <input type="text" disabled class="form-control" formControlName="coordinates"
                                        id="normal-cordinates">
                                </div>
                            </div>
                        </div>
                    </fieldset>
                </div>
            </section>
            <section class="widget" widget>
                <header>
                    <h6>
                        FloorPlans
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset>
                        <div class="col-12 text-right">
                            <button (click)="creatingFloorPlan = true" class="btn btn-primary rounded-circle">
                                <i class="fa fa-plus"></i>
                            </button>
                        </div>
                        <div class="table-responsive">
                            <table *ngIf="product.get('floorPlans').value.length > 0" class="table table-hover">
                                <thead>
                                    <tr>
                                        <th style="width: 55px;"></th>
                                        <th style="width: 50px;">#</th>
                                        <th>Name</th>
                                        <th>Size</th>
                                        <th>Bedrooms</th>
                                        <th>Bathrooms</th>
                                        <th>Unit</th>
                                        <th>Price</th>
                                        <th>Available</th>
                                        <th>Deposit</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr *ngFor="let floorPlan of product.get('floorPlans')? product.get('floorPlans').value:[]; let i = index"
                                        (click)="edit('floorPlans',i);creatingFloorPlan = true">
                                        <td>
                                            <span>
                                                <i style="cursor:pointer"
                                                    class="glyphicon glyphicon-remove-circle text-danger"
                                                    (click)="delete('floorPlans',i)"></i>
                                            </span>
                                        </td>
                                        <td>{{i + 1}}</td>
                                        <td>{{floorPlan.name}}</td>
                                        <td>{{floorPlan.size}}</td>
                                        <td>{{floorPlan.bedrooms == 0? 'Studio':floorPlan.bedrooms}}</td>
                                        <td>{{floorPlan.bathrooms}}</td>
                                        <td>{{floorPlan.unit}}</td>
                                        <td>{{floorPlan.price}}</td>
                                        <td>{{floorPlan.availability}}</td>
                                        <td>{{floorPlan.deposit}}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </fieldset>
                </div>
            </section>
            <section class="widget" widget>
                <header>
                    <h6>
                        Expense
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset>
                        <div class="col-12 text-right">
                            <button (click)="onDisplayLookup('expenses')" class="btn btn-primary rounded-circle"><i
                                    class="fa fa-plus"></i></button>
                        </div>
                        <div class="table-responsive">
                            <table *ngIf="product.get('expenses').value.length > 0" class="table table-hover">
                                <thead>
                                    <tr>
                                        <th style="width: 52px;"></th>
                                        <th style="width: 50px;">#</th>
                                        <th>Name</th>
                                        <th>Type</th>
                                        <th>Price</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr *ngFor="let expenses of product.get('expenses')? product.get('expenses').value:[]; let i = index"
                                        (click)="edit('expenses',i);creatingOfficeHour = true">
                                        <td>
                                            <span>
                                                <i style="cursor:pointer"
                                                    class="glyphicon glyphicon-remove-circle text-danger"
                                                    (click)="delete('expenses',i)"></i>
                                            </span>
                                        </td>
                                        <td>{{i + 1}}</td>
                                        <td>{{expenses.name}}</td>
                                        <td>{{expenses.type}}</td>
                                        <td>{{expenses.price}}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </fieldset>
                </div>
            </section>
            <section class="widget" widget>
                <header>
                    <h6>
                        Amenities
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset>
                        <div class="col-12 text-right">
                            <button (click)="onDisplayLookup('amenities')" class="btn btn-primary rounded-circle"><i
                                    class="fa fa-plus"></i></button>
                        </div>
                        <div class="table-responsive">
                            <table *ngIf="product.get('amenities').value.length > 0" class="table table-hover">
                                <thead>
                                    <tr>
                                        <th style="width: 52px;"></th>
                                        <th style="width: 50px;">#</th>
                                        <th>Name</th>
                                        <th>Category</th>
                                        <th>Title</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr *ngFor="let amenities of product.get('amenities')? product.get('amenities').value:[]; let i = index"
                                        (click)="edit('amenities',i);creatingOfficeHour = true">
                                        <td>
                                            <span>
                                                <i style="cursor:pointer"
                                                    class="glyphicon glyphicon-remove-circle text-danger"
                                                    (click)="delete('amenities',i)"></i>
                                            </span>
                                        </td>
                                        <td>{{i + 1}}</td>
                                        <td>{{amenities.name}}</td>
                                        <td>{{amenities.category}}</td>
                                        <td>{{amenities.title}}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </fieldset>
                </div>
            </section>
            <section class="widget" widget>
                <header>
                    <h6>
                        Office hours
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset>
                        <div class="col-12 text-right">
                            <button (click)="creatingOfficeHour = true" class="btn btn-primary rounded-circle"><i
                                    class="fa fa-plus"></i></button>
                        </div>
                        <div class="table-responsive">
                            <table *ngIf="product.get('officeHours').value.length > 0" class="table table-hover">
                                <thead>
                                    <tr>
                                        <th style="width: 52px;"></th>
                                        <th style="width: 50px;">#</th>
                                        <th>DayOfWeek</th>
                                        <th>Opens</th>
                                        <th>Closes</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr *ngFor="let officeHour of product.get('officeHours')? product.get('officeHours').value:[]; let i = index"
                                        (click)="edit('officeHours',i);creatingOfficeHour = true">
                                        <td>
                                            <span>
                                                <i style="cursor:pointer"
                                                    class="glyphicon glyphicon-remove-circle text-danger"
                                                    (click)="delete('officeHours',i)"></i>
                                            </span>
                                        </td>
                                        <td>{{i + 1}}</td>
                                        <td>{{officeHour.dayOfWeek}}</td>
                                        <td>{{officeHour.opens}}</td>
                                        <td>{{officeHour.closes}}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </fieldset>
                </div>
            </section>
            <section class="widget" widget>
                <header>
                    <h6>
                        Nearby
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset>
                        <div class="col-12 text-right">
                            <button (click)="creatingNearby = true" class="btn btn-primary rounded-circle"><i
                                    class="fa fa-plus"></i></button>
                        </div>
                        <div class="table-responsive">
                            <table *ngIf="product.get('nearby').value.length > 0" class="table table-hover">
                                <thead>
                                    <tr>
                                        <th style="width: 52px;"></th>
                                        <th style="width: 50px;">#</th>
                                        <th>Name</th>
                                        <th>category</th>
                                        <th>distance</th>
                                        <th>driving</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr *ngFor="let nearby of product.get('nearby')? product.get('nearby').value:[]; let i = index"
                                        (click)="edit('nearby',i);creatingNearby = true">
                                        <td>
                                            <span>
                                                <i style="cursor:pointer"
                                                    class="glyphicon glyphicon-remove-circle text-danger"
                                                    (click)="delete('nearby',i)"></i>
                                            </span>
                                        </td>
                                        <td>{{i + 1}}</td>
                                        <td>{{nearby.name}}</td>
                                        <td>{{nearby.category}}</td>
                                        <td>{{nearby.distance}}</td>
                                        <td>{{nearby.driving}}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </fieldset>
                </div>
            </section>
            <section class="widget" widget>
                <header>
                    <h6>
                        Schools
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset>
                        <div class="col-12 text-right">
                            <button (click)="creatingSchool = true" class="btn btn-primary rounded-circle"><i
                                    class="fa fa-plus"></i></button>
                        </div>
                        <div class="table-responsive">
                            <table *ngIf="product.get('schools').value.length > 0" class="table table-hover">
                                <thead>
                                    <tr>
                                        <th style="width: 52px;"></th>
                                        <th style="width: 50px;">#</th>
                                        <th>Type</th>
                                        <th>Category</th>
                                        <th>Grades</th>
                                        <th>Students</th>
                                        <th>Phone</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr *ngFor="let school of product.get('schools')? product.get('schools').value:[]; let i = index"
                                        (click)="edit('schools',i);creatingSchool = true">
                                        <td>
                                            <span>
                                                <i style="cursor:pointer"
                                                    class="glyphicon glyphicon-remove-circle text-danger"
                                                    (click)="delete('schools',i)"></i>
                                            </span>
                                        </td>
                                        <td>{{i + 1}}</td>
                                        <td>{{school.type}}</td>
                                        <td>{{school.category}}</td>
                                        <td>{{school.grades}}</td>
                                        <td>{{school.students}}</td>
                                        <td>{{school.phone}}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </fieldset>
                </div>
            </section>
            <section class="widget" widget>
                <header>
                    <h6>
                        Photos
                    </h6>
                    <div class="widget-controls">
                        <a data-widgster="collapse" title="Collapse">
                            <i class="la la-angle-up"></i>
                        </a>
                        <a data-widgster="expand" title="Expand">
                            <i class="la la-angle-down"></i>
                        </a>
                    </div>
                </header>
                <div class="widget-body">
                    <fieldset>
                        <div class="col-12 text-right">
                            <button (click)="creatingPhoto= true" class="btn btn-primary rounded-circle"><i
                                    class="fa fa-plus"></i></button>
                        </div>
                        <div class="table-responsive">
                            <table *ngIf="product.get('photos').value.length > 0" class="table table-hover">
                                <thead>
                                    <tr>
                                        <th style="width: 52px;"></th>
                                        <th style="width: 50px;">#</th>
                                        <th>Source</th>
                                        <th>Thumbnail</th>
                                        <th>Description</th>
                                        <th>MediaType</th>
                                        <th>Attachment Type</th>
                                        <th>Text</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr *ngFor="let photo of product.get('photos')? product.get('photos').value:[]; let i = index"
                                        (click)="edit('photos',i);creatingPhoto = true">
                                        <td>
                                            <span>
                                                <i style="cursor:pointer"
                                                    class="glyphicon glyphicon-remove-circle text-danger"
                                                    (click)="delete('photos',i)"></i>
                                            </span>
                                        </td>
                                        <td>{{i + 1}}</td>
                                        <td style="max-width: 200px; overflow: hidden; text-overflow: ellipsis;">{{photo.src}}</td>
                                        <td>{{photo.thumbnail}}</td>
                                        <td>{{photo.description}}</td>
                                        <td>{{photo.mediaType}}</td>
                                        <td>{{photo.attachmentType}}</td>
                                        <td>{{photo.altText}}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </fieldset>
                </div>
            </section>
        </div>
    </div>
</form>
<p-dialog header="Add floor plan" [(visible)]="creatingFloorPlan" [resizable]="true" closable="true"
    [style]="{'min-width':'300px', 'width':'550px'}" [contentStyle]="{'padding':'10px','min-width':'300px'}">
    <div style="width: 100%;">
        <ul class="nav nav-tabs float-left" id="myTab" role="tablist" style=" width: 100%; margin-bottom: 13px;">
            <li class="nav-item" (click)="view = 'home'">
              <a [ngClass]="{'active':view == 'home'}" class="nav-link">Home</a>
            </li>                     
            <li class="nav-item" (click)="view = 'photo'">
              <a [ngClass]="{'active':view == 'photo'}" class="nav-link">Photos</a>
            </li>                     
          </ul>
          <div [ngStyle]="{'display':view == 'home'? 'block':'none'}">
                <form [formGroup]="floorPlans">
                    <div class="form-group row">
                        <label for="normal-name" class="col-md-4  col-form-label text-md-right">Name</label>
                        <div class="col-md-7 ">
                            <input type="text" id="normal-floorPlan-name" formControlName="name" class="form-control"
                                placeholder="">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="normal-name" class="col-md-4  col-form-label text-md-right">Size</label>
                        <div class="col-md-7 ">
                            <input type="number" id="normal-floorPlan-size" formControlName="size" class="form-control"
                                placeholder="">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="normal-name" class="col-md-4  col-form-label text-md-right">Bedrooms</label>
                        <div class="col-md-7 ">
                            <p-dropdown [options]="bedrooms" [style]="{'min-width': '100%'}" formControlName="bedrooms"
                                [showClear]="true">
                            </p-dropdown>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="normal-name" class="col-md-4  col-form-label text-md-right">Bathrooms</label>
                        <div class="col-md-7 ">
                            <input type="number" id="normal-floorPlan-bathrooms" formControlName="bathrooms"
                                class="form-control" placeholder="">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="normal-name" class="col-md-4  col-form-label text-md-right">Unit</label>
                        <div class="col-md-7 ">
                            <input type="text" id="normal-floorPlan-unit" formControlName="unit" class="form-control"
                                placeholder="">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="normal-name" class="col-md-4  col-form-label text-md-right">Price</label>
                        <div class="col-md-7 ">
                            <div class="input-group">
                                <input type="number" [(ngModel)]="newPrice" [ngModelOptions]="{standalone: true}"
                                    id="normal-floorPlan-price" class="form-control" placeholder="">
                                <span class="input-group-append">
                                    <button (click)="addToData('newPrice', 'price', 'floorPlans')" type="button"
                                        class="btn btn-primary"><i class="fa fa-plus"></i></button>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div *ngFor="let price of floorPlans.get('price')? floorPlans.get('price').value:[]; let i = index"
                        class="form-group row">
                        <label for="ormal-floorPlan-available" class="col-md-4  col-form-label text-md-right">Price
                            {{i+1}}</label>
                        <div class="col-md-7 ">
                            <div class="input-group">
                                <input type="number" value="{{price}}" disabled class="form-control" placeholder="">
                                <span class="input-group-append">
                                    <button (click)="floorPlans.get('price').value.splice(i,1)" type="button"
                                        class="btn btn-primary"><i class="glyphicon glyphicon-remove-circle"></i></button>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="normal-name" class="col-md-4  col-form-label text-md-right">Availability</label>
                        <div class="col-md-7 ">
                            <p-autoComplete formControlName="availability" [suggestions]="filteredAvailability"
                                (completeMethod)="filterAvailability($event)" [style]="{'width':'300%'}" [size]="30"
                                [minLength]="1"></p-autoComplete>
                            <!--<input type="text" id="normal-floorPlan-availability" formControlName="availability" class="form-control"
                                placeholder="">-->
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="normal-name" class="col-md-4  col-form-label text-md-right">Deposit</label>
                        <div class="col-md-7 ">
                            <input type="number" id="normal-floorPlan-deposit" formControlName="deposit" class="form-control"
                                placeholder="">
                        </div>
                    </div>
                </form>
          </div>
          <div [ngStyle]="{'display':view == 'photo'? 'block':'none'}">
                <div class="text-right">
                    <button (click)="creatingPhotoFP = true" class="btn btn-primary rounded-circle"><i
                        class="fa fa-plus"></i></button>
                        <table *ngIf="floorPlans.get('photos').value" class="table table-hover">
                            <thead>
                                <tr>
                                    <th style="width: 52px;"></th>
                                    <th style="width: 50px;">#</th>
                                    <th>Source</th>
                                    <th>Description</th>                            
                                    <th>Text</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr *ngFor="let photo of floorPlans.get('photos')? floorPlans.get('photos').value:[]; let i = index"
                                    (click)="editPhotoFP(i);creatingPhotoFP = true">
                                    <td>
                                        <span>
                                            <i style="cursor:pointer"
                                                class="glyphicon glyphicon-remove-circle text-danger"
                                                (click)="deletePhotoFP(i)"></i>
                                        </span>
                                    </td>
                                    <td>{{i + 1}}</td>
                                    <td style="max-width: 100px; overflow: hidden; text-overflow: ellipsis;">{{photo.src}}</td>
                                    <td>{{photo.description}}</td>
                                    <td>{{photo.altText}}</td>
                                </tr>
                            </tbody>
                        </table>
                </div>
          </div>    
        </div>
    <p-footer>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;addFloorPlan()">Add</button>
        <button *ngIf="index != null" class="btn btn-outline-warning btn-sm"
            (click)="update('floorPlans');creatingFloorPlan=false">Edit</button>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;creatingFloorPlan=false">Cancel</button>
    </p-footer>
</p-dialog>
<p-dialog #pdoh header="Add office hour" [(visible)]="creatingOfficeHour" [resizable]="true" closable="true"
    [style]="{'min-width':'300px', 'width':'550px'}" [contentStyle]="{'padding':'10px','min-width':'300px'}">
    <div style="width: calc(100% - 20px);">
        <form [formGroup]="officeHours">
            <div class="form-group row">
                <label for="normal-name" class="col-md-4  col-form-label text-md-right">Day of week</label>
                <div class="col-md-7 ">
                    <p-multiSelect [options]="days" [style]="{'min-width': '100%'}" formControlName="dayOfWeek">
                    </p-multiSelect>
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-name" class="col-md-4  col-form-label text-md-right">Opens</label>
                <div class="col-md-7 ">
                    <input type="time" id="normal-expense-opens" formControlName="opens" class="form-control"
                        placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-name" class="col-md-4  col-form-label text-md-right">Closes</label>
                <div class="col-md-7 ">
                    <input type="time" id="normal-expense-closes" formControlName="closes" class="form-control"
                        placeholder="">
                </div>
            </div>
        </form>
    </div>
    <p-footer>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;addElemenet('officeHours')">Add</button>
        <button *ngIf="index != null" class="btn btn-outline-warning btn-sm"
            (click)="update('officeHours');creatingOfficeHour = false">Edit</button>
        <button class="btn btn-outline-secondary btn-sm"
            (click)="index = null;creatingOfficeHour = false;reset('officeHours')">Cancel</button>
    </p-footer>
</p-dialog>

<p-dialog header="Add {{title}}" [(visible)]="displayLookup" [resizable]="true" closable="true"
    [style]="{'min-width':'300px', 'width':'550px'}" [contentStyle]="{'padding':'0px','min-width':'300px'}">
    <p-table *ngIf="lookupFields" #dt [value]="lookup_data" [rows]="8" [paginator]="true" [responsive]="true"
        selectionMode="multiple" [(selection)]="lookup_selected" (onRowSelect)="lookup_callback()"
        (onRowUnselect)="lookup_callback()" [globalFilterFields]="globalFilterFields">
        <ng-template pTemplate="caption">
            <div style="text-align: left">
                <i class="fa fa-search" style="margin:4px 5px 8px 0px"></i>
                <input id="globalFilter" type="text" pInputText size="50" placeholder="Global Filter"
                    (input)="dt.filterGlobal($event.target.value, 'contains')" style="width:250px">
            </div>
        </ng-template>
        <ng-template pTemplate="header">
            <tr>
                <th class="ui-th" *ngFor="let col of lookupFields">
                    {{col.label}}
                </th>
            </tr>
        </ng-template>
        <ng-template pTemplate="body" let-data>
            <tr [pSelectableRow]="data">
                <td *ngFor="let col of lookupFields; let i = index">
                    {{data[col.name]}}
                </td>
            </tr>
        </ng-template>
    </p-table>
</p-dialog>

<p-dialog header="Add photos" [(visible)]="creatingPhoto" [resizable]="true" closable="true"
    [style]="{'min-width':'300px', 'width':'550px'}" [contentStyle]="{'padding':'10px','min-width':'300px'}">
    <div style="width: calc(100% - 20px);">
        <form [formGroup]="photos">
            <div class="form-group row">
                <label for="normal-src" class="col-md-4  col-form-label text-md-right">Source</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-src" formControlName="src" class="form-control" placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-thumbnail" class="col-md-4  col-form-label text-md-right">Thumbnail</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-thumbnail" formControlName="thumbnail" class="form-control"
                        placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-description" class="col-md-4  col-form-label text-md-right">Description</label>
                <div class="col-md-7 ">
                    <textarea rows="4" class="form-control" id="normal-description"
                        formControlName="description"></textarea>
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-mediaType" class="col-md-4  col-form-label text-md-right">Media Type</label>
                <div class="col-md-7 ">
                    <input type="number" id="normal-mediaType" formControlName="mediaType" class="form-control"
                        placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-attachmentType" class="col-md-4  col-form-label text-md-right">Attachment
                    type</label>
                <div class="col-md-7 ">
                    <input type="number" id="normal-attachmentType" formControlName="attachmentType"
                        class="form-control" placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-altText" class="col-md-4  col-form-label text-md-right">Text</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-altText" formControlName="altText" class="form-control"
                        placeholder="">
                </div>
            </div>
        </form>
    </div>
    <p-footer>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;addElemenet('photos')">Add</button>
        <button *ngIf="index != null" class="btn btn-outline-warning btn-sm"
            (click)="update('photos');creatingPhoto = false">Edit</button>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;creatingPhoto = false">Cancel</button>
    </p-footer>
</p-dialog>
<p-dialog header="Add photos" [(visible)]="creatingPhotoFP" [resizable]="true" closable="true"
    [style]="{'min-width':'300px', 'width':'550px'}" [contentStyle]="{'padding':'10px','min-width':'300px'}">
    <div style="width: calc(100% - 20px);">
        <form [formGroup]="photos">
            <div class="form-group row">
                <label for="normal-src" class="col-md-4  col-form-label text-md-right">Source</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-src" formControlName="src" class="form-control" placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-thumbnail" class="col-md-4  col-form-label text-md-right">Thumbnail</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-thumbnail" formControlName="thumbnail" class="form-control"
                        placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-description" class="col-md-4  col-form-label text-md-right">Description</label>
                <div class="col-md-7 ">
                    <textarea rows="4" class="form-control" id="normal-description"
                        formControlName="description"></textarea>
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-mediaType" class="col-md-4  col-form-label text-md-right">Media Type</label>
                <div class="col-md-7 ">
                    <input type="number" id="normal-mediaType" formControlName="mediaType" class="form-control"
                        placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-attachmentType" class="col-md-4  col-form-label text-md-right">Attachment
                    type</label>
                <div class="col-md-7 ">
                    <input type="number" id="normal-attachmentType" formControlName="attachmentType"
                        class="form-control" placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-altText" class="col-md-4  col-form-label text-md-right">Text</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-altText" formControlName="altText" class="form-control"
                        placeholder="">
                </div>
            </div>
        </form>
    </div>
    <p-footer>
        <button class="btn btn-outline-secondary btn-sm" (click)="index2 = null;addPhotoFP()">Add</button>
        <button *ngIf="index2 != null" class="btn btn-outline-warning btn-sm"
            (click)="updatePhotoFP();creatingPhotoFP = false">Edit</button>
        <button class="btn btn-outline-secondary btn-sm" (click)="index2 = null;creatingPhotoFP = false">Cancel</button>
    </p-footer>
</p-dialog>
<p-dialog header="Add closeness" [(visible)]="creatingNearby" [resizable]="true" closable="true"
    [style]="{'min-width':'300px', 'width':'550px'}" [contentStyle]="{'padding':'10px','min-width':'300px'}">
    <div style="width: calc(100% - 20px);">
        <form [formGroup]="nearby">
            <div class="form-group row">
                <label for="normal-name" class="col-md-4  col-form-label text-md-right">Name</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-name" formControlName="name" class="form-control" placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-category" class="col-md-4  col-form-label text-md-right">Category</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-category" formControlName="category" class="form-control"
                        placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-distance" class="col-md-4  col-form-label text-md-right">Distance</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-distance" formControlName="distance" class="form-control"
                        placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-driving" class="col-md-4  col-form-label text-md-right">Driving</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-driving" formControlName="driving" class="form-control"
                        placeholder="">
                </div>
            </div>

        </form>
    </div>
    <p-footer>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;addElemenet('nearby')">Add</button>
        <button *ngIf="index != null" class="btn btn-outline-warning btn-sm"
            (click)="update('nearby');creatingNearby= false">Edit</button>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;creatingNearby= false">Cancel</button>
    </p-footer>
</p-dialog>
<p-dialog header="Add schools" [(visible)]="creatingSchool" [resizable]="true" closable="true"
    [style]="{'min-width':'300px', 'width':'550px'}" [contentStyle]="{'padding':'10px','min-width':'300px'}">
    <div style="width: calc(100% - 20px);">
        <form [formGroup]="schools">
            <div class="form-group row">
                <label for="normal-type" class="col-md-4  col-form-label text-md-right">Type</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-type" formControlName="type" class="form-control" placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-category" class="col-md-4  col-form-label text-md-right">Category</label>
                <div class="col-md-7 ">
                    <p-dropdown [options]="schoolCategory" [style]="{'min-width': '100%'}" formControlName="category"
                        showClear="true">
                    </p-dropdown>
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-grades" class="col-md-4  col-form-label text-md-right">Grades</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-grades" formControlName="grades" class="form-control" placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-students" class="col-md-4  col-form-label text-md-right">Students</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-students" formControlName="students" class="form-control"
                        placeholder="">
                </div>
            </div>
            <div class="form-group row">
                <label for="normal-phone" class="col-md-4  col-form-label text-md-right">Phone</label>
                <div class="col-md-7 ">
                    <input type="text" id="normal-phone" formControlName="phone" class="form-control" placeholder="">
                </div>
            </div>

        </form>
    </div>
    <p-footer>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;addElemenet('schools')">Add</button>
        <button *ngIf="index != null" class="btn btn-outline-warning btn-sm"
            (click)="update('schools');creatingPhoto = false">Edit</button>
        <button class="btn btn-outline-secondary btn-sm" (click)="index = null;creatingSchool = false">Cancel</button>
    </p-footer>
</p-dialog>

<p-dialog header="Add address" [(visible)]="addressLookup" closable="true" [contentStyle]="{'padding':'0px'}"
    (onShow)="addressOnShow()">
    <div class="m-2">
        <input type="text" id="addressSearch" class="form-control" style="width: 300px;">
    </div>
    <!--<div id="map" style="height: 400px; margin: 5px"></div>-->
</p-dialog>